=== added file 'src/com/goldencode/p2j/testengine/FWDProcedureMethodTestDescriptor.java'
--- src/com/goldencode/p2j/testengine/FWDProcedureMethodTestDescriptor.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/FWDProcedureMethodTestDescriptor.java	2022-10-28 14:36:09 +0000
@@ -0,0 +1,118 @@
+/*
+** Module   : FWDProcedureMethodTestDescriptor.java
+** Abstract : Test descriptor for a legacy internal procedure.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import java.lang.reflect.*;
+import java.util.*;
+
+import com.goldencode.p2j.util.*;
+
+/**
+ * Test descriptor for a legacy internal procedure.
+ */
+public class FWDProcedureMethodTestDescriptor
+extends AbstractMethodTestDescriptor
+{
+
+   /**
+    * Default constructor, required for de-serialization
+    */
+   public FWDProcedureMethodTestDescriptor()
+   {
+      // no-op
+   }
+
+   /**
+    * Constructor.
+    * 
+    * @param parent 
+    *        the parent descriptor
+    * @param clazz
+    *        the Java class to create instances
+    * @param execute
+    *        the method to execute
+    * @param beforeEach
+    *        methods to execute before the execute method
+    * @param afterEach
+    *        methods to execute after the execute method
+    */
+   FWDProcedureMethodTestDescriptor(AbstractClassTestDescriptor parent, Class<?> clazz,
+            Method execute, List<Method> beforeEach, List<Method> afterEach)
+   {
+      super(parent, clazz, execute, beforeEach, afterEach);
+   }
+
+   /**
+    * Execute a method.
+    *  
+    * @param method
+    *        the method to execute
+    * @param o
+    *        the object to use, must be a procedure handle
+    */
+   @Override
+   protected void callMethodImpl(final Method method, final Object o)
+   {
+      TestExecutionSupport.callProcedureMethod(method, (handle) o);
+   }
+
+}

=== added file 'src/com/goldencode/p2j/testengine/FWDProcedureTestDescriptor.java'
--- src/com/goldencode/p2j/testengine/FWDProcedureTestDescriptor.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/FWDProcedureTestDescriptor.java	2022-10-28 14:43:23 +0000
@@ -0,0 +1,200 @@
+/*
+** Module   : FWDProcedureTestDescriptor.java
+** Abstract : Test descriptor for a legacy procedure.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import java.lang.reflect.*;
+import java.util.*;
+
+import org.junit.platform.engine.*;
+import org.junit.platform.engine.support.hierarchical.*;
+
+import com.goldencode.p2j.util.*;
+
+/**
+ * Test descriptor for a legacy procedure.
+ */
+public class FWDProcedureTestDescriptor
+extends AbstractClassTestDescriptor
+{
+
+   /**
+    * Persistent procedure instance to invoke the methods on.
+    * 
+    * Unlike JUnit5, the same instance is used to run all test methods
+    * for a procedure.
+    */
+   transient handle procedure;
+
+   /**
+    * Default constructor, required for de-serialization
+    */
+   public FWDProcedureTestDescriptor()
+   {
+      // no-op
+   }
+
+   /**
+    * The constructor.
+    * 
+    * @param clazz
+    *        the Java class
+    * @param parent
+    *        the parent descriptor
+    * @param test
+    *        class methods marked as tests  
+    * @param beforeEach
+    *        class methods marked to execute before each test  
+    * @param afterEach
+    *        class methods marked to execute after each test  
+    * @param beforeAll
+    *        class methods marked to execute before all tests  
+    * @param afterAll
+    *        class methods marked to execute after all tests  
+    */
+   FWDProcedureTestDescriptor(Class<?> clazz, TestDescriptor parent, List<Method> test,
+            List<Method> beforeEach, List<Method> afterEach, List<Method> beforeAll,
+            List<Method> afterAll)
+   {
+      super(clazz, parent, test, beforeEach, afterEach, beforeAll, afterAll);
+      // Create method descriptors for "each" type methods
+      test.stream().map(
+               m -> new FWDProcedureMethodTestDescriptor(this, clazz, m, beforeEach, afterEach))
+               .forEach(this::addChild);
+
+   }
+
+   /**
+    * Clean up the supplied {@code context} after execution implementation.
+    * 
+    * Reset the test class instance.
+    * 
+    * @throws Exception 
+    *
+    * @see #prepare
+    */
+   @Override
+   public void cleanUpImpl() throws Exception
+   {
+      // TODO do we need to do any additional cleanup?
+      procedure = null;
+   }
+
+   /**
+    * Prepare the supplied {@code context} prior to execution implementation.
+    * 
+    * @throws Exception 
+    *
+    * @see #cleanUpImpl
+    */
+   @Override
+   public void prepareImpl() throws Exception
+   {
+      try
+      {
+         // Locate the execute() method
+         final Method m = clazz.getDeclaredMethod("execute");
+         final LegacySignature annotation = m.getAnnotation(LegacySignature.class);
+         final String name = annotation.name();
+         final handle h = new handle();
+         new InvokeConfig(name).persistent().setProcedureHandle(h).run();
+         procedure = h;
+      }
+      catch (NoSuchMethodException | SecurityException e)
+      {
+         throw new RuntimeException(e);
+      }
+   }
+
+   /**
+    * Get test object. The test object is either a legacy class instance if tests are implemented
+    * as legacy class methods or a persistent procedure instance it tests are implemented as
+    * internal procedures.
+    * 
+    * The value should be {@code null} if the test method is a static legacy class method.
+    * 
+    * The value is created in class test descriptor {@link Node#prepare(EngineExecutionContext)},
+    * and destroyed in {@link Node#cleanUp(EngineExecutionContext)}.
+    * 
+    * @return the test object or {@code null}
+    *         
+    */
+   @Override
+   protected Object getTestObject()
+   {
+      return procedure;
+   }
+
+   /**
+    * Execute a method.
+    *  
+    * @param method
+    *        the method to execute
+    * @param o
+    *        the object to use, can be {@code null} for "static" methods. 
+    */
+   @Override
+   protected void callMethodImpl(Method method, Object o)
+   {
+      TestExecutionSupport.callProcedureMethod(method, (handle) o);
+   }
+
+}

=== added file 'src/com/goldencode/p2j/testengine/FWDTestEngine.java'
--- src/com/goldencode/p2j/testengine/FWDTestEngine.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/FWDTestEngine.java	2022-10-27 14:44:37 +0000
@@ -0,0 +1,401 @@
+/*
+** Module   : FWDTestEngine.java
+** Abstract : Test engine.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import org.junit.platform.engine.*;
+import org.junit.platform.engine.discovery.*;
+import org.junit.platform.engine.support.hierarchical.*;
+
+import com.goldencode.p2j.cfg.*;
+import com.goldencode.p2j.directory.*;
+import com.goldencode.p2j.main.*;
+import com.goldencode.p2j.net.*;
+import com.goldencode.p2j.net.Session;
+import com.goldencode.p2j.security.*;
+import com.goldencode.p2j.security.SecurityManager;
+import com.goldencode.p2j.ui.chui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.driver.*;
+import com.goldencode.p2j.util.*;
+
+/**
+ * FWD Test engine.
+ *
+ */
+public class FWDTestEngine
+extends HierarchicalTestEngine<FWDEngineExecutionContext>
+{
+
+   /**
+    * Flag indicating this engine is disabled.
+    * 
+    * If this engine initialization ended with an exception, it does not throw the exception,
+    * but continue disabled instead. Disabled engine will never discover any tests.
+    * 
+    * This feature let other test engines a chance to work.
+    */
+   private boolean disabled;
+   
+   /**
+    * The session. Created in the {@link #initialize(BootstrapConfig)}, and
+    * closed in {@link #shutdown(BootstrapConfig)}.
+    */
+   private static Session session;
+
+   /**
+    * Unit test support on the server proxy instance.
+    */
+   private static UnitTestEngine unitTestSupport;
+
+   /**
+    * Fill in the bootstrap configuration with some fixed values.
+    * 
+    * WARNING: this method is a temporary replacement for the normal
+    * FWD bootstrap configuration process. It must be used for debugging only!
+    *  
+    * WARNING: the values compiled in should be probably edited manually
+    *  
+    * @return
+    *        the configuration instance
+    *        
+    * @throws ConfigurationException
+    */
+   private static BootstrapConfig initConfig() throws ConfigurationException
+   {
+      final BootstrapConfig bc = new BootstrapConfig(null, null, null, null);
+
+      bc.setServer(false);
+
+      bc.setConfigItem("net", "queue", "conversation", "true");
+
+      // either way, force start thread to false (this client is going to
+      // use its main thread as the conversation thread so we don't need
+      // to start one
+      bc.setConfigItem("net", "queue", "start_thread", "false");
+
+      // TODO: these configuration statements are temporarily for initial debugging only!!! 
+      bc.setConfigItem("net", "server", "host", "localhost");
+      bc.setConfigItem("net", "connection", "secure", "false");
+      bc.setConfigItem("net", "server", "secure_port", "4434");
+      bc.setConfigItem("net", "server", "insecure_port", "4534");
+      bc.setConfigItem("client", "driver", "type", "gui_swing");
+      bc.setConfigItem("client", "driver", "theme",
+               "com.goldencode.p2j.ui.client.gui.theme.Windows10Theme");
+      return bc;
+   }
+
+   /**
+    * Initialize FWD client process.
+    * 
+    * @param config
+    *        the input bootstrap configuration
+    *        
+    * @throws Exception
+    */
+   private static void initialize(final BootstrapConfig config) throws Exception
+   {
+      // Load native library
+      System.loadLibrary("p2j");
+      ClientCore.processInit();
+
+      SecurityManager.createInstance(config);
+
+      // instantiate network session manager
+      final SessionManager sessMgr = SessionManagerFactory.createLeafNode(config);
+
+      // initialize core UI services
+      ThinClient.initializePrep(config, null /* driver */, false);
+
+      final ScreenDriver<?> driver = OutputManager.getDriver();
+
+      // establish or re-establish a session with the P2J server
+      // (this handles authentication too)
+      session = sessMgr.connectDirect(new InterruptedExceptionHandler(), null);
+
+      // some client code must read configuration from the directory
+      DirectoryManager.initRemote(session);
+
+      // FIXME: do we really need this MainEntry?
+      final MainEntry main = (MainEntry) RemoteObject.obtainNetworkInstance(MainEntry.class,
+               session);
+
+      final String projectToken = config.getString("client", "project", "token", null);
+      // this will set the token from either client:project:token or directory's project_token.
+      main.setProjectToken(projectToken);
+
+      // attempt to emulate the '-ininame' command-line parameter:
+      String iniFileName = config.getString("client", "cmd-line-option", "ininame", "");
+
+      final Directory remoteDir = DirectoryManager.getInstance();
+      if (iniFileName.isEmpty() && remoteDir != null)
+      {
+         iniFileName = remoteDir.getString(Directory.ID_RELATIVE, "ininame", "");
+      }
+
+      // finish initializing the thin client
+      ThinClient.initializePost(config, session, null, main.loadStartupParameters(), iniFileName);
+
+      if (remoteDir != null)
+      {
+         // initialize the Ease Access Manager
+         EaseAccessManager.init(remoteDir);
+      }
+
+      ThinClient.loadEnvironment(config);
+
+      // After full initialization of the client code we can set up the ErrorWriter for
+      // client side.
+      if (session != null)
+      {
+         OutputManager.initErrorWriter(session);
+      }
+
+      // initializeLogger();
+      // outputDiagnostics(config, diag);
+
+      // determine any client-side parameters
+      ClientParameters params = processClientParams(driver, config);
+
+      // Propagate client-side parameters to the server
+      main.setClientParams(params);
+      ThinClient.setClientParameters(params);
+
+      if (params.clientlog != null)
+      {
+         ThinClient.initClientLog(params.clientlog);
+      }
+
+      // initialize initial tooltip settings
+      ThinClient.setSessionTooltips();
+
+      // above this point, any CTRL-C processing that causes a STOP
+      // condition to be thrown will cause an exit (this is very timing
+      // sensitive but if you hold down the CTRL-C keys AND the server
+      // environment is configured to force a relogin (the return from
+      // standardEntry() is true) then at some point you will see such
+      // an exception; we can protect against this, BUT this same behavior
+      // has been seen in the 4GL, so it has been left here on purpose
+
+      // Activates batch mode if exists. If batch mode operation is requested the real work
+      // should be postponed until all subsystems to be initialized properly using usual
+      // console mode. At this point this preliminary work should be done and we can
+      // "activate" the special processing for batch mode. 
+      if (OutputManager.inBatchMode())
+      {
+         OutputManager.activateBatch(true);
+      }
+
+      driver.clientReady();
+      ThinClient.getInstance().updateClientMetrics();
+
+      // set up current user name for client session
+      ThinClient.getInstance().setUserName(params.osUserName);
+
+      unitTestSupport = (UnitTestEngine) RemoteObject.obtainNetworkInstance(UnitTestEngine.class,
+               session);
+
+      // Do server-side initialization
+      unitTestSupport.initialize();
+   }
+
+   /**
+    * Create a {@link ClientParameters} instance from {@link BootstrapConfig}.
+    * 
+    * @param driver
+    *        screen driver
+    * @param config
+    *        input bootstrap config
+    * 
+    * @return the instance created
+    */
+   private static ClientParameters processClientParams(final ScreenDriver<?> driver,
+            final BootstrapConfig config)
+   {
+      final ClientParameters cp = new ClientParameters();
+      final String win = driver.getWindowSystem();
+
+      cp.windowSystem = config.getString("client", "driver", "window-system", win);
+      cp.param = config.getString("client", "cmd-line-option", "param", null);
+      cp.startupProc = config.getString("client", "cmd-line-option", "startup-procedure", null);
+      cp.clientlog = config.getString("client", "cmd-line-option", "clientlog", null);
+      cp.osUserName = ClientCore.getUserName();
+      cp.terminalName = config.getString("client", "tty", "name", null);
+      cp.debugAlert = config.getBoolean("client", "cmd-line-option", "debugalert", false);
+      cp.errorStack = config.getBoolean("client", "cmd-line-option", "errorstack", false);
+      cp.pid = ClientCore.getPid();
+      cp.chui = driver.isChui();
+      cp.batchMode = config.getBoolean("client", "mode", "batch", false) ? 2 : 0;
+      cp.socketTrustStoreFilename = config.getString("ssl-socket", "truststore", "location",
+               "trusted-cert.store");
+      cp.socketTrustStorePassword = config.getString("ssl-socket", "truststore", "password", "");
+
+      return cp;
+   }
+
+   /**
+    * Terminate FWD client process.
+    * 
+    * FIXME: method is not used now
+    * 
+    * @param config
+    *        input bootstrap config
+    * @throws RestrictedUseException
+    */
+   @SuppressWarnings("unused")
+   private final static void shutdown(final BootstrapConfig config) throws RestrictedUseException
+   {
+      //dependent threads need to be shutdown, even if the client restarts on CTRL-C
+      ThinClient.terminate();
+
+      OutputManager.getDriver().shutdown();
+
+      // shut down session
+      session.terminate();
+
+      // clear after me
+      SecurityManager.clearInstance();
+   }
+
+   /**
+    * Default constructor.
+    */
+   public FWDTestEngine()
+   {
+      // process configuration. In most use cases (e.g. running from IDE), it is not possible to pass
+      // any command line arguments: so only config files can be used for the purpose.
+      try
+      {
+         final BootstrapConfig bc = initConfig();
+
+         initialize(bc);
+      }
+      catch (Throwable thr)
+      {
+         System.err.println("Test engine cannot initialize and will be disabled: " + thr);
+         disabled = true;
+      }
+
+   }
+
+   /**
+    * Discover tests according to the supplied {@link EngineDiscoveryRequest}.
+    *
+    * <p>The supplied {@link UniqueId} must be used as the unique ID of the
+    * returned root {@link TestDescriptor}. In addition, the {@code UniqueId}
+    * must be used to create unique IDs for children of the root's descriptor
+    * by calling {@link UniqueId#append}.
+    *
+    * @param discoveryRequest the discovery request; never {@code null}
+    * @param uniqueId the unique ID to be used for this test engine's
+    * {@code TestDescriptor}; never {@code null}
+    * @return the root {@code TestDescriptor} of this engine, typically an
+    * instance of {@code EngineDescriptor}
+    * @see org.junit.platform.engine.support.descriptor.EngineDescriptor
+    */
+   @Override
+   public TestDescriptor discover(final EngineDiscoveryRequest discoveryRequest,
+            final UniqueId uniqueId)
+   {
+      if (disabled)
+      {
+         return new NoopDescriptor(UniqueId.forEngine(getId()), "No-op");
+      }
+      
+      return unitTestSupport.discover(uniqueId,
+               discoveryRequest.getSelectorsByType(PackageSelector.class).stream()
+                        .map(PackageSelector::getPackageName).toArray(String[]::new),
+               discoveryRequest.getSelectorsByType(ClassSelector.class).stream()
+                        .map(ClassSelector::getClassName).toArray(String[]::new),
+               discoveryRequest.getSelectorsByType(MethodSelector.class).stream()
+                        .map(s -> s.getClassName() + "#" + s.getMethodName())
+                        .toArray(String[]::new));
+   }
+
+   /**
+    * Get the ID that uniquely identifies this test engine.
+    *
+    * <p>Each test engine must provide a unique ID. For example, JUnit Vintage
+    * and JUnit Jupiter use {@code "junit-vintage"} and {@code "junit-jupiter"},
+    * respectively. When in doubt, you may use the fully qualified name of your
+    * custom {@code TestEngine} implementation class.
+    */
+   @Override
+   public String getId()
+   {
+      // Note: "junit-fwd" would be more natural, but the "junit-" prefix
+      // is reserved by JUnit5
+      return "fwd-junit";
+   }
+
+   /**
+    * Create the initial execution context for executing the supplied
+    * {@linkplain ExecutionRequest request}.
+    *
+    * @param request the request about to be executed
+    * @return the initial context that will be passed to nodes in the hierarchy
+    */
+   @Override
+   protected FWDEngineExecutionContext createExecutionContext(ExecutionRequest request)
+   {
+      return new FWDEngineExecutionContext(unitTestSupport);
+   }
+}

